using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using DadaodotNET;

namespace DadaodotNetDemo
{
    public partial class Form1 : Form
    {
        byte[] key = new byte[] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };
       // SoundPlayer simpleSound;

        public Form1()
        {
            InitializeComponent();

          //  simpleSound = new SoundPlayer(".\\succ.wav");
        }

        private void btnReadM1_Click(object sender, EventArgs e)
        {
            
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                //SystemSounds.Question.Play();
                MessageBox.Show("Ѱʧ");
                return;
            }

            int a = (int)blocksel.Value;
            string s = string.Empty;
            if (TypeACard.RFIDRead((byte)a, key, TypeACard.KEYA, buffer, ref dwLen, 2000))
            {
                for(int i = 0; i < (int)dwLen; i++)
                {
                    s += buffer[i].ToString("X2");
                }

                tbResult.Text = s;
                Sound sound = new Sound(Properties.Resources.succ);
                sound.Play();
            }
            else
            {
                MessageBox.Show("ʧ");
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TypeACard.RFIDPowerOn();
            cbocard.SelectedIndex = 0;

            cboBaud.SelectedIndex = 1;
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            TypeACard.RFIDPowerOff();
        }

        private byte[] HexStringToByteArray(string s)
        {
            if (s.Length % 2 == 1)
            {
                s = "0" + s;
            }

            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        } 

        private void btnWriteM1_Click(object sender, EventArgs e)
        {
            byte[] data = HexStringToByteArray(tbResult.Text);
            byte[] blkdata = new byte[16];

            if ((blocksel.Value + 1) % 4 == 0 || blocksel.Value == 0)
            {
                MessageBox.Show("дԿ0");
                return;
            }

            for (int i = 0; i < data.Length && i < 16; i++)
            {
                blkdata[i] = data[i];
            }

            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("Ѱʧ");
                return;
            }

            int a = (int)blocksel.Value;
            string s = string.Empty;
            if (TypeACard.RFIDWrite((byte)a, key, TypeACard.KEYA, blkdata, 2000))
            {
                Sound sound = new Sound(Properties.Resources.succ);
                sound.Play();
            }
            else
            {
                MessageBox.Show("дʧ");
            }

        }

        private void tbValue_KeyDown(object sender, KeyEventArgs e)
        {
           
        }

        private void tbValue_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar >= '0' && e.KeyChar <= '9')
            {
                //e.Handled = false;
            }
            else
                e.Handled = true;
        }

        private void btnInit_Click(object sender, EventArgs e)
        {
          
            byte[] blkdata = new byte[16];

            Array.Clear(blkdata, 0, blkdata.Length);

            if ((blocksel.Value + 1) % 4 == 0 || blocksel.Value == 0)
            {
                MessageBox.Show("дԿ0");
                return;
            }

            blkdata[4] = 0xff;
            blkdata[5] = 0xff;
            blkdata[6] = 0xff;
            blkdata[7] = 0xff;

            blkdata[12] = (byte)blocksel.Value;
            blkdata[13] = (byte)~blkdata[12];
            blkdata[14] = (byte)~blkdata[13];
            blkdata[15] = (byte)~blkdata[14];

            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("Ѱʧ");
                return;
            }

            int a = (int)blocksel.Value;
            string s = string.Empty;
            if (TypeACard.RFIDWrite((byte)a, key, TypeACard.KEYA, blkdata, 2000))
            {
                Sound sound = new Sound(Properties.Resources.succ);
                sound.Play();
            }
            else
            {
                MessageBox.Show("дʧ");
            }
        }

        private void btnAdd_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("Ѱʧ");
                return;
            }

            int a = (int)blocksel.Value;
            int value = Convert.ToInt32(tbValue.Text);


            if (TypeACard.increment((byte)a, key, value, TypeACard.KEYA, 2000))
            {
                Sound sound = new Sound(Properties.Resources.succ);
                sound.Play();
            }
            else
            {
                MessageBox.Show("ʧ");
            }
        }

        private void btnSub_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("Ѱʧ");
                return;
            }

            int a = (int)blocksel.Value;
            int value = Convert.ToInt32(tbValue.Text);


            if (TypeACard.decrement((byte)a, key, value, TypeACard.KEYA, 2000))
            {
                Sound sound = new Sound(Properties.Resources.succ);
                sound.Play();
            }
            else
            {
                MessageBox.Show("ʧ");
            }
        }

        private void btnCpuReset_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!TypeACard.RFIDSearch(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("Ѱʧ");
                return;
            }

            if (!TypeACard.CPUReset(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("RESETʧ");
                return;
            }

            string s = string.Empty;
            for (int i = 0; i < (int)dwLen; i++)
            {
                s += buffer[i].ToString("X2");
            }

            tbCPUResult.Text = s;
            Sound sound = new Sound(Properties.Resources.succ);
            sound.Play();
        }

        private void btnCpuCOS_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            byte[] data = HexStringToByteArray(tbCOS.Text);

            if (!TypeACard.CPUCosCmd(data, data.Length, buffer, ref dwLen, 2000))
            {
                MessageBox.Show("COSʧ");
                return;
            }

            string s = string.Empty;
            for (int i = 0; i < (int)dwLen; i++)
            {
                s += buffer[i].ToString("X2");
            }

            tbCPUResult.Text = s;
            Sound sound = new Sound(Properties.Resources.succ);
            sound.Play();
        }

        private void btnPSAMReset_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!PSAM.PSAMReset((byte)cbocard.SelectedIndex, (byte)cboBaud.SelectedIndex, buffer, ref dwLen, 2000))
            {
                MessageBox.Show("RESETʧ");
                return;
            }

            string s = string.Empty;
            for (int i = 0; i < (int)dwLen; i++)
            {
                s += buffer[i].ToString("X2");
            }

            tbPSAMResult.Text = s;
            Sound sound = new Sound(Properties.Resources.succ);
            sound.Play();
        }

        private void btnPSAMCOS_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            byte[] data = HexStringToByteArray(tbCOS.Text);

            if (!PSAM.PSAMCosCmd((byte)cbocard.SelectedIndex, (byte)cboBaud.SelectedIndex, data, data.Length, buffer, ref dwLen, 2000))
            {
                MessageBox.Show("COSʧ");
                return;
            }

            string s = string.Empty;
            for (int i = 0; i < (int)dwLen; i++)
            {
                s += buffer[i].ToString("X2");
            }

            tbPSAMResult.Text = s;
            Sound sound = new Sound(Properties.Resources.succ);
            sound.Play();
        }

        private void btnBarCodeRead_Click(object sender, EventArgs e)
        {
            IntPtr dwLen = IntPtr.Zero;
            byte[] buffer = new byte[128];

            if (!BarCode.BarCodeRead(buffer, ref dwLen, 2000))
            {
                MessageBox.Show("ʧ");
                return;
            }

            ASCIIEncoding encoding = new ASCIIEncoding();

            string s = encoding.GetString(buffer, 0, (int)dwLen);

            tbBarResult.Text = s;
            Sound sound = new Sound(Properties.Resources.succ);
            sound.Play();
        }
    }
}